<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<!-- Generated by Apache Maven Doxia at Jan 15, 2013 ( $Revision$ ) -->
<!-- $HeadURL: https://svn.apache.org/repos/asf/httpcomponents/maven-skin/trunk/src/main/resources/META-INF/maven/site.vm $ -->
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
  <head>
    <meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
    <title>HttpClient - HttpClient Logging Practices</title>
    <style type="text/css" media="all">
      @import url("./css/maven-base.css");
      @import url("./css/maven-theme.css");
      @import url("./css/site.css");
    </style>
    <link rel="stylesheet" href="./css/print.css" type="text/css" media="print" />
    <meta name="Date-Revision-yyyymmdd" content="20130115" />
    <meta http-equiv="Content-Language" content="en" />
        
        </head>
  <body class="composite">
    <div id="banner">
                        <a href="http://www.apache.org/" id="bannerLeft">
                                        <img src="http://www.apache.org/images/asf_logo_wide.gif" alt="Apache" />
                </a>
                                            <a href="../" id="bannerRight">
                                                <img src="../images/logos/httpcomponents.png" alt="HttpComponents" />
                </a>
            <div class="clear">
        <hr/>
      </div>
    </div>
    <div id="breadcrumbs">
            
        
                <div class="xleft">
        <span id="publishDate">Last Published: 2013-01-15</span>
                  &nbsp;| <span id="projectVersion">Version: 4.2.3</span>
                      </div>
            <div class="xright">                    <a href="http://www.apache.org/" class="externalLink" title="Apache">Apache</a>
            |
                        <a href="../index.html" title="HttpComponents">HttpComponents</a>
              
        
      </div>
      <div class="clear">
        <hr/>
      </div>
    </div>
    <div id="leftColumn">
      <div id="navcolumn">
             
        
                                <h5>HttpComponents</h5>
                  <ul>
                  <li class="none">
                          <a href="../index.html" title="Home">Home</a>
            </li>
                  <li class="none">
                          <a href="http://www.apache.org/licenses/" class="externalLink" title="License">License</a>
            </li>
                  <li class="none">
                          <a href="../downloads.cgi" title="Download">Download</a>
            </li>
                  <li class="none">
                          <a href="../mail.html" title="Mailing Lists">Mailing Lists</a>
            </li>
                  <li class="none">
                          <a href="../user-docs.html" title="User documents">User documents</a>
            </li>
                  <li class="none">
                          <a href="../dev-docs.html" title="Developer documents">Developer documents</a>
            </li>
                  <li class="none">
                          <a href="http://wiki.apache.org/HttpComponents/" class="externalLink" title="Wiki (external)">Wiki (external)</a>
            </li>
                  <li class="none">
                          <a href="http://www.apache.org/security/" class="externalLink" title="Security">Security</a>
            </li>
          </ul>
                       <h5>HttpClient Overview</h5>
                  <ul>
                  <li class="none">
                          <a href="index.html" title="Description">Description</a>
            </li>
                  <li class="none">
                          <a href="quickstart.html" title="Quick Start">Quick Start</a>
            </li>
          </ul>
                       <h5>Documentation</h5>
                  <ul>
                  <li class="none">
                          <a href="tutorial/html/index.html" title="Tutorial">Tutorial</a>
            </li>
                  <li class="none">
                          <a href="examples.html" title="Examples">Examples</a>
            </li>
                  <li class="none">
                          <a href="primer.html" title="Client HTTP Programming Primer">Client HTTP Programming Primer</a>
            </li>
                  <li class="none">
                          <a href="ntlm.html" title="NTLM Guide">NTLM Guide</a>
            </li>
                  <li class="none">
            <strong>Logging</strong>
          </li>
          </ul>
                       <h5>Modules</h5>
                  <ul>
                  <li class="none">
                          <a href="httpclient/index.html" title="HttpClient">HttpClient</a>
            </li>
                  <li class="none">
                          <a href="httpmime/index.html" title="HttpMime">HttpMime</a>
            </li>
                  <li class="none">
                          <a href="httpclient-cache/index.html" title="HttpClient Cache">HttpClient Cache</a>
            </li>
                  <li class="none">
                          <a href="fluent-hc/index.html" title="Fluent HC">Fluent HC</a>
            </li>
          </ul>
                       <h5>Project Documentation</h5>
                  <ul>
                                                                                                                          <li class="collapsed">
                          <a href="project-info.html" title="Project Information">Project Information</a>
                  </li>
          </ul>
                       <h5>ASF</h5>
                  <ul>
                  <li class="none">
                          <a href="http://www.apache.org" class="externalLink" title="ASF Home Page">ASF Home Page</a>
            </li>
                  <li class="none">
                          <a href="http://www.apache.org/foundation/" class="externalLink" title="Foundation">Foundation</a>
            </li>
                  <li class="none">
                          <a href="http://www.apache.org/foundation/sponsorship.html" class="externalLink" title="Sponsor Apache">Sponsor Apache</a>
            </li>
                  <li class="none">
                          <a href="http://www.apache.org/foundation/thanks.html" class="externalLink" title="Thanks">Thanks</a>
            </li>
          </ul>
                                                                                                                   <a href="http://www.apache.org/events/current-event.html" title="ApacheCon" class="poweredBy">
        <img class="poweredBy"  alt="ApacheCon" src="http://www.apache.org/events/current-event-125x125.png"    />
      </a>
                                                                                                    <a href="http://maven.apache.org/" title="Maven" class="poweredBy">
        <img class="poweredBy"  alt="Maven" src="http://maven.apache.org/images/logos/maven-feather.png"    />
      </a>
                       
        
            </div>
    </div>
    <div id="bodyColumn">
      <div id="contentBox">
        <!-- ==================================================================== --><!-- Licensed to the Apache Software Foundation (ASF) under one --><!-- or more contributor license agreements.  See the NOTICE file --><!-- distributed with this work for additional information --><!-- regarding copyright ownership.  The ASF licenses this file --><!-- to you under the Apache License, Version 2.0 (the --><!-- "License"); you may not use this file except in compliance --><!-- with the License.  You may obtain a copy of the License at --><!--  --><!-- http://www.apache.org/licenses/LICENSE-2.0 --><!--  --><!-- Unless required by applicable law or agreed to in writing, --><!-- software distributed under the License is distributed on an --><!-- "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY --><!-- KIND, either express or implied.  See the License for the --><!-- specific language governing permissions and limitations --><!-- under the License. --><!-- ==================================================================== --><!--  --><!-- This software consists of voluntary contributions made by many --><!-- individuals on behalf of the Apache Software Foundation.  For more --><!-- information on the Apache Software Foundation, please see --><!-- <http://www.apache.org/>. --><div class="section"><h2>Logging Practices<a name="Logging_Practices"></a></h2><p>Being a library HttpClient is not to dictate which logging framework the user has to use. Therefore HttpClient utilizes the logging interface provided by the <a class="externalLink" href="http://commons.apache.org/logging/">Commons Logging</a> package. <tt>Commons Logging</tt> provides a simple and generalized <a class="externalLink" href="http://commons.apache.org/logging/commons-logging-1.0.4/docs/apidocs/">log interface</a> to various logging packages. By using <tt>Commons Logging</tt>, HttpClient can be configured for a variety of different logging behaviours. That means the user will have to make a choice which logging framework to use. By default <tt>Commons Logging</tt> supports the following logging frameworks:</p><ul><li><a class="externalLink" href="http://logging.apache.org/log4j/docs/index.html">Log4J</a></li><li><a class="externalLink" href="http://java.sun.com/j2se/1.4.2/docs/api/java/util/logging/package-summary.html"> java.util.logging</a></li><li><a class="externalLink" href="http://commons.apache.org/logging/commons-logging-1.0.4/docs/apidocs/org/apache/commons/logging/impl/SimpleLog.html"> SimpleLog</a> (internal to <tt>Commons Logging</tt>)<p>By implementing some simple interfaces <tt>Commons Logging</tt> can be extended to support basically any other custom logging framework. <tt>Commons Logging</tt> tries to automatically discover the logging framework to use. If it fails to select the expected one, you must configure <tt>Commons Logging</tt> by hand. Please refer to the <tt>Commons Logging</tt> documentation for more information.</p><p>HttpClient performs three different kinds of logging: the standard context logging used within each class, HTTP header logging and full wire logging. </p></li></ul><div class="section"><h3><a name="Context_Logging">Context Logging</a></h3><p>Context logging contains information about the internal operation of HttpClient as it performs HTTP requests. Each class has its own log named according to the class's fully qualified name. For example the class <tt>DefaultHttpClient</tt> has a log named <tt>org.apache.http.impl.client.DefaultHttpClient</tt>. Since all classes follow this convention it is possible to configure context logging for all classes using the single log named <tt>org.apache.http.impl.client</tt>.</p></div><div class="section"><h3><a name="Wire_Logging">Wire Logging</a></h3><p>The wire log is used to log all data transmitted to and from servers when executing HTTP requests. The wire log uses the <tt>org.apache.http.wire</tt> logging category. This log should only be enabled to debug problems, as it will produce an extremely large amount of log data.</p></div><div class="section"><h3><a name="HTTP_header_Logging">HTTP header Logging</a></h3><p>Because the content of HTTP requests is usually less important for debugging than the HTTP headers, the <tt>org.apache.http.headers</tt> logging category for capturing HTTP headers only.</p></div><div class="section"><h3><a name="Configuration_Examples">Configuration Examples</a></h3><p><tt>Commons Logging</tt> can delegate to a variety of loggers for processing the actual output. Below are configuration examples for <tt>Commons Logging</tt>, <tt>Log4j</tt> and <tt>java.util.logging</tt>.</p><div class="section"><h4><a name="Commons_Logging_Examples">Commons Logging Examples</a></h4><p><tt>Commons Logging</tt> comes with a basic logger called <tt>SimpleLog</tt>. This logger writes all logged messages to <tt>System.err</tt>. The following examples show how to configure <tt>Commons Logging</tt> via system properties to use <tt>SimpleLog</tt>. It is strongly recommended to configure <tt>Commons Logging</tt> system properties through JVM process arguments at the start up.</p><ul><li>Enable header wire + context logging - <b>Best for Debugging</b><div><pre>-Dorg.apache.commons.logging.Log=org.apache.commons.logging.impl.SimpleLog
-Dorg.apache.commons.logging.simplelog.showdatetime=true
-Dorg.apache.commons.logging.simplelog.log.org.apache.http=DEBUG
-Dorg.apache.commons.logging.simplelog.log.org.apache.http.wire=ERROR</pre></div></li><li>Enable full wire + context logging<div><pre>-Dorg.apache.commons.logging.Log=org.apache.commons.logging.impl.SimpleLog
-Dorg.apache.commons.logging.simplelog.showdatetime=true
-Dorg.apache.commons.logging.simplelog.log.org.apache.http=DEBUG</pre></div></li><li>Enable context logging for connection management<div><pre>-Dorg.apache.commons.logging.Log=org.apache.commons.logging.impl.SimpleLog
-Dorg.apache.commons.logging.simplelog.showdatetime=true
-Dorg.apache.commons.logging.simplelog.log.org.apache.http.impl.conn=DEBUG</pre></div></li><li>Enable context logging for connection management / request execution<div><pre>-Dorg.apache.commons.logging.Log=org.apache.commons.logging.impl.SimpleLog
-Dorg.apache.commons.logging.simplelog.showdatetime=true
-Dorg.apache.commons.logging.simplelog.log.org.apache.http.impl.conn=DEBUG
-Dorg.apache.commons.logging.simplelog.log.org.apache.http.impl.client=DEBUG
-Dorg.apache.commons.logging.simplelog.log.org.apache.http.client=DEBUG</pre></div></li></ul></div><div class="section"><h4><a name="Log4j_Examples">Log4j Examples</a></h4><p>The simplest way to configure <tt>Log4j</tt> is via a <tt>log4j.properties</tt> file. <tt>Log4j</tt> will automatically read and configure itself using a file named <tt>log4j.properties</tt> when it's present at the root of the application classpath. Below are some <tt>Log4j</tt> configuration examples.</p><p><b>Note:</b> <tt>Log4j</tt> is not included in the <tt>HttpClient</tt> distribution. </p><ul><li>Enable header wire + context logging - <b>Best for Debugging</b><div><pre>log4j.rootLogger=INFO, stdout

log4j.appender.stdout=org.apache.log4j.ConsoleAppender
log4j.appender.stdout.layout=org.apache.log4j.PatternLayout
log4j.appender.stdout.layout.ConversionPattern=%5p [%c] %m%n

log4j.logger.org.apache.http=DEBUG
log4j.logger.org.apache.http.wire=ERROR</pre></div></li><li>Enable full wire + context logging<div><pre>log4j.rootLogger=INFO, stdout

log4j.appender.stdout=org.apache.log4j.ConsoleAppender
log4j.appender.stdout.layout=org.apache.log4j.PatternLayout
log4j.appender.stdout.layout.ConversionPattern=%5p [%c] %m%n

log4j.logger.org.apache.http=DEBUG</pre></div></li><li>Enable context logging for connection management<div><pre>log4j.rootLogger=INFO, stdout

log4j.appender.stdout=org.apache.log4j.ConsoleAppender
log4j.appender.stdout.layout=org.apache.log4j.PatternLayout
log4j.appender.stdout.layout.ConversionPattern=%5p [%c] %m%n

log4j.logger.org.apache.http.impl.conn=DEBUG</pre></div></li><li>Enable context logging for connection management / request execution<div><pre>log4j.rootLogger=INFO, stdout

log4j.appender.stdout=org.apache.log4j.ConsoleAppender
log4j.appender.stdout.layout=org.apache.log4j.PatternLayout
log4j.appender.stdout.layout.ConversionPattern=%5p [%c] %m%n

log4j.logger.org.apache.http.impl.conn=DEBUG
log4j.logger.org.apache.http.impl.client=DEBUG
log4j.logger.org.apache.http.client=DEBUG</pre></div></li></ul><p>Note that the default configuration for Log4J is very inefficient as it causes all the logging information to be generated but not actually sent anywhere. The <tt>Log4J</tt> manual is the best reference for how to configure <tt>Log4J</tt>. It is available at <a class="externalLink" href="http://logging.apache.org/log4j/docs/manual.html"> http://logging.apache.org/log4j/docs/manual.html</a>.</p></div><div class="section"><h4><a name="java.util.logging_Examples">java.util.logging Examples</a></h4><p>Since JDK 1.4 there has been a package <a class="externalLink" href="http://java.sun.com/j2se/1.4.2/docs/api/java/util/logging/package-summary.html"> java.util.logging</a> that provides a logging framework similar to <tt>Log4J</tt>. By default it reads a config file from <tt>$JAVA_HOME/jre/lib/logging.properties</tt> which looks like this (comments stripped):</p><div><pre>handlers=java.util.logging.ConsoleHandler
.level=INFO
java.util.logging.FileHandler.pattern = %h/java%u.log
java.util.logging.FileHandler.limit = 50000
java.util.logging.FileHandler.count = 1
java.util.logging.FileHandler.formatter = java.util.logging.XMLFormatter
java.util.logging.ConsoleHandler.level = INFO
java.util.logging.ConsoleHandler.formatter = java.util.logging.SimpleFormatter
com.xyz.foo.level = SEVERE</pre></div><p>To customize logging a custom <tt>logging.properties</tt> file should be created in the project directory. The location of this file must be passed to the JVM as asystem property. This can be done on the command line like so:</p><div><pre>$JAVA_HOME/java -Djava.util.logging.config.file=$HOME/myapp/logging.properties
-classpath $HOME/myapp/target/classes com.myapp.Main</pre></div><p>Alternatively <a class="externalLink" href="http://java.sun.com/j2se/1.4.2/docs/api/java/util/logging/LogManager.html#readConfiguration(java.io.InputStream)&quot;"> LogManager#readConfiguration(InputStream)</a> can be used to pass it the desired configuration.</p><ul><li>Enable header wire + context logging - <b>Best for Debugging</b><div><pre>.level = INFO

handlers=java.util.logging.ConsoleHandler
java.util.logging.ConsoleHandler.formatter = java.util.logging.SimpleFormatter
java.util.logging.ConsoleHandler.level = ALL

org.apache.http.level = FINEST
org.apache.http.wire.level = SEVERE</pre></div></li><li>Enable full wire + context logging<div><pre>.level = INFO

handlers=java.util.logging.ConsoleHandler
java.util.logging.ConsoleHandler.formatter = java.util.logging.SimpleFormatter
java.util.logging.ConsoleHandler.level = ALL

org.apache.http.level = FINEST</pre></div></li><li>Enable context logging for connection management<div><pre>.level = INFO

handlers=java.util.logging.ConsoleHandler
java.util.logging.ConsoleHandler.formatter = java.util.logging.SimpleFormatter
java.util.logging.ConsoleHandler.level = ALL

org.apache.http.impl.conn.level = FINEST</pre></div></li><li>Enable context logging for connection management / request execution<div><pre>.level = INFO

handlers=java.util.logging.ConsoleHandler
java.util.logging.ConsoleHandler.formatter = java.util.logging.SimpleFormatter
java.util.logging.ConsoleHandler.level = ALL

org.apache.http.impl.conn.level = FINEST
org.apache.http.impl.client.level = FINEST
org.apache.http.client.level = FINEST</pre></div></li></ul><p>More detailed information is available from the <a class="externalLink" href="http://java.sun.com/j2se/1.4.2/docs/guide/util/logging/overview.html"> Java Logging documentation</a>.</p></div></div></div>
      </div>
    </div>
    <div class="clear">
      <hr/>
    </div>
    <div id="footer">
                      
<div class="xleft">Apache HttpComponents, Commons HttpClient, Apache, the Apache feather logo, and the Apache HttpComponents project logo are trademarks of The Apache Software Foundation.</div>
            
<br/>
            
<div class="xleft">All other marks mentioned may be trademarks or registered trademarks of their respective owners.</div>
                <div class="xright">Copyright &#169;                    1999-2013
                        <a href="http://www.apache.org/">The Apache Software Foundation</a>.
            All Rights Reserved.      
        
      </div>
      <div class="clear">
        <hr/>
      </div>
    </div>
  </body>
</html>
